//
//  Model.swift
//  PlanetHex
//
//  Created by Don McBrien on 01/03/2020.
//  Copyright © 2020 Don McBrien. All rights reserved.
//

import Foundation
import HexagonTiledTorus

class Model {
   var vertices: [Vertex]
   var indices = [UInt16]()

   init(hexPairsWide: Int, hexColumnHeight: Int, ringRadius: Float) {
      let torus = HexagonTiledTorus(hexPairsWide: hexPairsWide, hexColumnHeight: hexColumnHeight, ringRadius: ringRadius)
      self.vertices = torus.vertices
      let triangles = torus.indices
      for t in triangles {
         indices.append(t.x)
         indices.append(t.y)
         indices.append(t.z)
      }
      torus.printInitialisationReport()
   }
}
