//
//  Shaders.metal
//  PlanetHex
//
//  Created by Don McBrien on 27/02/2020.
//  Copyright © 2020 Don McBrien. All rights reserved.
//

#include <metal_stdlib>
using namespace metal;

struct VertexInOut {
   float4 position [[position]];
   float4 color;
};

vertex VertexInOut vertex_main(constant VertexInOut *vertices [[buffer(0)]],
                             constant float4x4 &matrix [[buffer(1)]],
//                             constant float &timer [[ buffer(2) ]],
                             uint id [[vertex_id]])
{
   VertexInOut vertex_out {
//      .position = vertices[id].position,
      .position = matrix * vertices[id].position,
      .color = vertices[id].color
   };
   return vertex_out;
}

fragment float4 fragment_main(VertexInOut inFrag [[stage_in]])
{
   return inFrag.color;
}
