//
//  ViewController.swift
//  PlanetHex
//
//  Created by Don McBrien on 22/02/2020.
//  Copyright © 2020 Don McBrien. All rights reserved.
//

import Cocoa
import HexagonTiledTorus
import MetalKit

class ViewController: NSViewController {
   var model: Model!
   var metalView: MTKView!
   var renderer: Renderer!
   
   override func viewDidLoad() {
      super.viewDidLoad()
      
      model = Model(hexPairsWide: 9, hexColumnHeight: 12, ringRadius: 0.5 )

      prepareMetal()
   }
   
   func prepareMetal() {
      // First we recast self.view as an MTKView and store the reference
      guard let metalViewTemp = self.view as? MTKView else {
         fatalError("View attached to ViewController is not an MTKView!")
      }
      metalView = metalViewTemp
      
      // Then we create an instance of our Renderer object ...
      guard let tempRenderer = Renderer(view: metalView, model: model) else {
         fatalError("Renderer failed to initialize")
      }
      renderer = tempRenderer
      
      // ... and set it as the delegate of metalView
      metalView.delegate = renderer
   }
}

